Projet_final/WebApplication_ProjFinal/Models/DefaultDbContext.cs
using Microsoft.EntityFrameworkCore;
using twitch.api;
using static Microsoft.EntityFrameworkCore.DbLoggerCategory.Database;


namespace WebApplication_ProjFinal.Models
{
	public class DefaultDbContext : DbContext
	{
		public DbSet<Twitcher> twitchers { get; set; }
		public DbSet<Subscriber> subscribers { get; set; }
		public DbSet<Streaming> Streaming { get; set; }
		public DbSet<Gift> gifts { get; set; }

		public DefaultDbContext(DbContextOptions options) : base(options)
		{
		}

		protected DefaultDbContext()
		{
		}

		protected override void OnModelCreating(ModelBuilder builder)
		{
			//builder.Entity<GLearn>();
			//builder.Entity<GOffer>();
			//builder.Entity<GShare>();
			//builder.Entity<GDiscount>();

			base.OnModelCreating(builder);
		}
		//protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
		//{
		//	optionsBuilder.Configuration.GetConnectionString("Default");
		//	//optionsBuilder.UseSqlServer("connection_string_here");
		//}

	}
}

Projet_final/WebApplication_ProjFinal/Models/ErrorViewModel.cs
namespace WebApplication_ProjFinal.Models
{
	public class ErrorViewModel
	{
		public string? RequestId { get; set; }

		public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
	}
}

Projet_final/WebApplication_ProjFinal/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;
using twitch.api.Adapters;
using twitch.api;
using WebApplication_ProjFinal.Models;

namespace WebApplication_ProjFinal.Controllers
{
	public class HomeController : Controller
	{
		private readonly ILogger<HomeController> _logger;
		private readonly DefaultDbContext context;

		public HomeController(ILogger<HomeController> logger, DefaultDbContext context)
		{
			_logger = logger;
			this.context = context;
		}

		public IActionResult Index()
		{
            var query = from item in this.context.Streaming
                        select item;

            var streamings = query.ToList(); // Traduction, requete linq en requete sql
            foreach (var item in streamings)
            {
				item.Status = item.getStatus();
            }
            return View(streamings);
		}

		public IActionResult Privacy()
		{
			return View();
		}

		[ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
		public IActionResult Error()
		{
			return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
		}
	}
}

Projet_final/WebApplication_ProjFinal/Controllers/SubscriberController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using twitch.api;
using WebApplication_ProjFinal.Models;
using static Microsoft.EntityFrameworkCore.DbLoggerCategory;

namespace WebApplication_ProjFinal.Controllers
{
	public class SubscriberController : Controller
	{
		private readonly DefaultDbContext context;

		public SubscriberController(DefaultDbContext context)
		{
			this.context = context;
		}

		public IActionResult Index()
		{
			var query = from item in this.context.subscribers
						where item.IsConnected == true
						select item;

            var subscribers = query.ToList(); // Traduction, requete linq en requete sql

            ViewData["info"] = "connectés";
            ViewData["subscribers"] = subscribers;
			return View();
		}

        public IActionResult filterFollowers()
        {
            // J'ai mis en place la bdd pour pouvoir avoir plusieurs twitchers,
            // mais pour l'instant on est dans un système où il n'y en a qu'un

            List<Subscriber> subscribers = new List<Subscriber>();

            Twitcher twitcher = context.twitchers.Find(1);
            int idStreamer = 1;

            var selectValue = this.Request.Form["followers"];

            if (selectValue == "all")
            {
                var query = from item in this.context.subscribers
                        where item.Twitchers.Contains(twitcher)
                        select item;
                subscribers = query.ToList();
                ViewData["info"] = "(tous)";
            }
            if (selectValue == "connected")
            {
                var query = from item in this.context.subscribers
                        where item.IsConnected == true
                        where item.Twitchers.Contains(twitcher)
                        select item;
                subscribers = query.ToList();
                ViewData["info"] = "connectés";
            }
            if (selectValue == "favfollowers")
            {
                int nbStreams = this.context.Streaming.Count(s => s.Streamer.Id == idStreamer);
                double seuilFidelite = Math.Ceiling(nbStreams * 0.7);

                // requete linq à établir :
                // parmi les streams et le follower
                // join
                // where stream.streamer = stream
                // select stream.followers
                // où follower.streams.count = seuil 

                var query = from stream in this.context.Streaming
                            where stream.Streamer == twitcher
                            from follower in stream.SubscribersConnected
                            group follower by follower into followerGroup
                            where followerGroup.Count() >= seuilFidelite
                            select followerGroup.Key;

                subscribers = query.ToList();
                ViewData["info"] = "favoris";
            }
            ViewData["subscribers"] = subscribers;
            return View("Index");
        }
    }
}

Projet_final/WebApplication_ProjFinal/Controllers/TwitcherController.cs
using Azure.Core;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json.Linq;
using twitch.api;
using WebApplication_ProjFinal.Models;
using static System.Runtime.InteropServices.JavaScript.JSType;

namespace WebApplication_ProjFinal.Controllers
{
    public class TwitcherController : Controller
    {
        private readonly DefaultDbContext context;

        public TwitcherController(DefaultDbContext context)
        {
            this.context = context;
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public IActionResult createStream()
        {
            return View("streamForm");
        }

        [HttpPost]
        public IActionResult createStream(Streaming streaming)
        {
            var twitcher = context.twitchers.Find(1);
            if (streaming.Id == 0)
            {
                streaming.Streamer = twitcher;
                this.context.Streaming.Add(streaming);
            }
            else
            {
                Streaming streamToUpdate = this.context.Streaming.Find(streaming.Id);
                streamToUpdate.Title = streaming.Title;
                streamToUpdate.StartTime = streaming.StartTime;

                if (streaming.ChangeStatus == true)
                {
                    var actualStatus = streamToUpdate.getStatus();

                    if (actualStatus == StatutStream.AVenir)
                    {
                        streamToUpdate.StartTime = DateTime.Now;
                    }
                    if (actualStatus == StatutStream.EnCours)
                    {
                        streamToUpdate.EndTime = DateTime.Now;
                    }
                }

            }
            this.context.SaveChanges();

            return RedirectToAction("Index", "Home");
        }

        public IActionResult editStream(int  id)
        {
            Streaming stream = context.Streaming.Find(id);
            stream.Status = stream.getStatus();


            return View("streamForm", stream);
        }
    }
}

Projet_final/WebApplication_ProjFinal/Views/Home/Index.cshtml
@model List<Streaming>
@{
    @using twitch.api;
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    
    <form asp-area="" asp-action="createStream" asp-controller="Twitcher" method="get">
        <h1 class="display-4">
            <button class="btn btn-primary" type="submit">Créer un nouveau stream</button>
        </h1>
    </form>
</div>
<h2 class="text-center mt-5 mb-3">Tableau des streams</h2>
<table class="table">
    <thead>
        <tr>
            <th scope="col">Date et heure du stream</th>
            <th scope="col">Titre</th>
            <th scope="col">statut</th>
            <th scope="col"></th>
        </tr>
    </thead>
    <tbody>

        @foreach(var item in this.Model)
        {
            <tr>
                <td>@item.StartTime.Value.ToString("dd / MM yyyy HH:mm:ss")</td>
                <td>@item.Title</td>
                @switch (item.Status)
                {
                    case StatutStream.EnCours:
                    <td>en cours</td>
                    break;
                    case StatutStream.AVenir:
                    <td>à venir</td>
                    break;
                    case StatutStream.Fini:
                    <td>fini</td>
                    break;
                }
                <td>
                    @if (item.Status != StatutStream.Fini)
                    {
                        <a class="btn btn-danger" asp-area="" asp-action="editStream" asp-controller="Twitcher" asp-route-id="@item.Id">Editer</a>
                    }
                </td>
            </tr>
        }
    </tbody>
</table>

Projet_final/WebApplication_ProjFinal/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - WebApplication_ProjFinal</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/WebApplication_ProjFinal.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">WebApplication_ProjFinal</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Subscriber" asp-action="Index">Followers</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - WebApplication_ProjFinal - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

Projet_final/WebApplication_ProjFinal/Views/Subscriber/Index.cshtml
@using twitch.api;
@{
    List<Subscriber> subscribers = ViewData["subscribers"] as List<Subscriber>;
    var info = ViewData["info"];
}
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}
<label for="followers-select">Afficher :</label>

<form asp-action="filterFollowers" asp-controller="Subscriber" method="post">
    <select name="followers" id="followers-select">
        <option value="">--liste des options--</option>
        <option value="all">Tous les subscribers</option>
        <option value="connected">Tous les subscribers connectés</option>
        <option value="favfollowers">Les subscribers les plus fidèles</option>
    </select>
    <button>valider</button>
</form>

<h1>Liste des followers @info</h1>

<table class="table">
    <thead>
        <tr><td scope="col">Nom</td>
            <td scope="col">Mail</td>
            <td scope="col">Avatar</td>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in subscribers)
{
    <tr>
            <td>@item.Name </td><td>@item.Email</td><td><img class="avatarPic" src="/pics/@item.ProfilePic" alt="avatar"></td>
    </tr>
}
    </tbody>
</table>

Projet_final/WebApplication_ProjFinal/Views/Twitcher/streamForm.cshtml
    @*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    @model Streaming;
    @using twitch.api;
}
@if (Model != null)
{
    <h1>Modifier le stream #@Model.Id @Model.Title</h1>
} else
{
    <h1>Créer un nouveau stream</h1>
}
<form asp-action="createStream" asp-controller="Twitcher" method="post" class="col-8">
        <label class="col-form-label">date du stream</label>
    @if (Model != null)
    {
        <input hidden name="id" value="@Model.Id"/>
        <input name="startTime" class="form-control" value="@Model.StartTime.Value.ToString("yyyy-MM-ddThh:mm")" type="datetime-local" />
    } else
    {
        <input hidden name="id" value=""/>
        <input type="datetime-local" name="startTime" class="form-control" />

    }
        <label class="col-form-label">titre</label>
    @if (Model != null)
    {
        <input type="text" name="title" class="form-control" value="@Model.Title"/>
    }
    else
    {
        <input type="text" name="title" class="form-control" />

    }

    @if (Model != null && Model.Status != StatutStream.Fini)
    {
        <div class="form-check form-switch mt-4">
            <input class="form-check-input" type="checkbox" role="switch" id="switchStatus" name="changeStatus" value="true">
            @if (Model.Status == StatutStream.AVenir)
            {
                <label class="form-check-label" for="switchStatus">Commencer le stream</label>
            }
            @if (Model.Status == StatutStream.EnCours)
            {
                <label class="form-check-label" for="switchStatus">Finir le stream</label>
            }
        </div>
    }
  <div class="col-8">
        <button type="submit" class="btn btn-primary mt-4">Valider</button>
    </div>

</form>